package precision;

import java.security.InvalidParameterException;

import precision.model.IPreciseDoubleFactory;
import precision.model.IPrecisionConfiguration;
import precision.model.PreciseDouble;

public final class PreciseDoubleFactory implements IPreciseDoubleFactory 
{
	
	private IPrecisionConfiguration precisionConfiguration;
	
	public PreciseDoubleFactory(IPrecisionConfiguration precisionConfiguration)
	{
		if (precisionConfiguration == null)
			throw new InvalidParameterException();
		
		this.precisionConfiguration = precisionConfiguration;
	}
	
	@Override
	public PreciseDouble create(double value) 
	{
		return new PreciseDouble(value, this.precisionConfiguration);
	}

}
