package precision.model;

/**
 * Precision parameters.
 */
public interface IPrecisionConfiguration 
{
	/**
	 * The number of trusted decimal digits in coordinates representation.
	 */
	public int accuracy();
	
	/**
	 * Precalculated representation of accuracy as (accuracy ^ 10).
	 */
	public long iEpsilon();
	
	/**
	 * Precalculated representation of accuracy as 1 / (accuracy ^ 10).
	 */
	public double epsilon();
	
	/**
	 * The distance values under the distanceDelta are treated as zero distances.
	 */
	public double distanceDelta();
	
	/**
	 * Comparing distances.
	 */
	public int compareDistance(double distance1, double distance2);
	
	/**
	 * Comparing distances.
	 */
	public int compareWithAccuracy(double value1, double value2);
	
}
