package spatial;

import spatial.geometry.Edge3d;
import spatial.model.IGeometry;
import spatial.model.elements.IEdge;
import spatial.model.elements.INode;

final class Edge implements IEdge 
{

	private INode nodeA;
	
	private INode nodeB;
	
	private String name;
	
	public Edge(INode nodeA, INode nodeB) 
	{
		if (nodeA == null)
			throw new IllegalArgumentException("nodeA");
		if (nodeB == null)
			throw new IllegalArgumentException("nodeB");
		
		this.nodeA = nodeA;
		this.nodeB = nodeB;
		this.name = nodeA.name() + nodeB.name();
	}
	
	public Edge(String name2, Edge3d geometry) 
	{
		// TODO Auto-generated constructor stub
	}

	@Override
	public INode nodeA()
	{
		return this.nodeA;
	}

	@Override
	public INode nodeB() 
	{
		return this.nodeB;
	}

	@Override
	public String name() 
	{
		return this.name;
	}

	@Override
	public int hashCode()
	{
		return (41 * 43 + this.nodeA.hashCode()) * 43 + this.nodeB.hashCode();
	}
	
	@Override
	public boolean equals(Object other) 
	{	
		if (other == null || this.getClass() != other.getClass())
			return false;
		if (this == other)
			return true;
		Edge otherEdge = (Edge) other;

		return this.nodeA.equals(otherEdge.nodeA) && this.nodeB.equals(otherEdge.nodeB);
	}
	
	@Override
	public String toString()
	{
		return this.name;
	}

	@Override
	public IGeometry geometry() {
		// TODO Auto-generated method stub
		return null;
	}
}
