package spatial;

import precision.PrecisionConfiguration;
import precision.model.IPrecisionConfiguration;
import spatial.model.ISpatialModel;
import spatial.model.elements.set.IEdgeSet;
import spatial.model.elements.set.INodeSet;

public final class SpatialModel implements ISpatialModel 
{
	private final IPrecisionConfiguration precisionConfiguration;
	
	private final INodeSet nodeSet;
	
	private final IEdgeSet edgeSet;
	
	public SpatialModel()
	{
		this.precisionConfiguration = new PrecisionConfiguration();
		this.nodeSet = new NodeSet();
		this.edgeSet = new EdgeSet();
	}
	
	@Override
	public final INodeSet nodes() 
	{
		return this.nodeSet;
	}

	@Override
	public final IEdgeSet edges() 
	{
		return this.edgeSet;
	}

	@Override
	public IPrecisionConfiguration precisionConfiguration() 
	{
		return this.precisionConfiguration;
	}

}
