package spatial.algorithms.bestFittingPlane;

import spatial.algorithms.AlgorithmResultBase;
import spatial.geometry.Plane3d;
import spatial.model.algorithms.bestFittingPlane.IBestFittingPlaneResult;

final class BestFittingPlaneResult extends AlgorithmResultBase implements IBestFittingPlaneResult
{
	private final Plane3d bestFittingPlane;
	
	private final double[] sourcePointsDistances;
	
	public BestFittingPlaneResult(Plane3d bestFittingPlane, double[] sourcePointsDistances)
	{
		this.bestFittingPlane = bestFittingPlane;
		this.sourcePointsDistances = sourcePointsDistances;
	}

	public BestFittingPlaneResult(String[] errors)
	{
		super(errors);
		
		this.bestFittingPlane = null;
		this.sourcePointsDistances = null;
	}

	@Override
	public Plane3d bestFittingPlane()
	{
		return this.bestFittingPlane;
	}

	@Override
	public double[] sourcePointsDistances()
	{
		return this.sourcePointsDistances;
	}

}
