package spatial.algorithms.edgeToFaceLocation;

import spatial.algorithms.AlgorithmResultBase;
import spatial.model.algorithms.edgeToFaceLocation.EdgeToFaceLocationKind;
import spatial.model.algorithms.edgeToFaceLocation.IEdgeToFaceLocationResult;

final class EdgeToFaceLocationResult extends AlgorithmResultBase implements IEdgeToFaceLocationResult
{

	private final EdgeToFaceLocationKind locationKind;
	
	public EdgeToFaceLocationResult(EdgeToFaceLocationKind locationKind)
	{
		if (locationKind == null)
			throw new IllegalArgumentException("Location kind is not defined.");
		
		this.locationKind = locationKind;
	}

	public EdgeToFaceLocationResult(String[] errors)
	{
		super(errors);

		this.locationKind = null;
	}

	@Override
	public EdgeToFaceLocationKind locationKind()
	{
		return this.locationKind;
	}

}
