package spatial.algorithms.edgeToPolygonLocation;

import spatial.algorithms.AlgorithmResultBase;
import spatial.model.algorithms.edgeToPolygonLocation.EdgeToPolygonLocationKind;
import spatial.model.algorithms.edgeToPolygonLocation.IEdgeToPolygonLocationResult;

final class EdgeToPolygonLocationResult extends AlgorithmResultBase implements IEdgeToPolygonLocationResult
{
	private final EdgeToPolygonLocationKind locationKind;
	
	public EdgeToPolygonLocationResult(EdgeToPolygonLocationKind locationKind)
	{
		if (locationKind == null)
			throw new IllegalArgumentException("The Location Kind is not defined");
		
		this.locationKind = locationKind;
	}

	public EdgeToPolygonLocationResult(String[] errors)
	{
		super(errors);

		this.locationKind = null;
	}

	@Override
	public EdgeToPolygonLocationKind locationKind()
	{
		return this.locationKind;
	}

}
