package spatial.algorithms.faceArea;

import precision.model.IPrecisionConfiguration;
import spatial.algorithms.AlgorithmBase;
import spatial.algorithms.polygonArea.PolygonAreaAlgorithm;
import spatial.geometry.Face2d;
import spatial.model.algorithms.faceArea.IFaceAreaAlgorithm;
import spatial.model.algorithms.faceArea.IFaceAreaResult;
import spatial.model.algorithms.polygonArea.IPolygonAreaAlgorithm;
import spatial.model.algorithms.polygonArea.IPolygonAreaResult;

public final class FaceAreaAlgorithm extends AlgorithmBase<IFaceAreaResult> implements IFaceAreaAlgorithm
{

	public FaceAreaAlgorithm(IPrecisionConfiguration precisionConfiguration)
	{
		super(precisionConfiguration);
	}

	@Override
	public IFaceAreaResult calculate(Face2d face)
	{
		double sum = 0;
		
		for (int i = 0; i < face.polygons().length; i++)
		{
			IPolygonAreaAlgorithm algorithm = new PolygonAreaAlgorithm(this.precisionConfiguration);
			IPolygonAreaResult result = algorithm.calculate(face.polygons()[i]);
			
			sum += result.area();
		}
		
		return new FaceAreaResult(sum);
	}

	@Override
	protected void calculateInternal()
	{
	
	}

	@Override
	protected IFaceAreaResult constructResult()
	{
		return null;
	}

	@Override
	protected IFaceAreaResult constructErrorsResult()
	{
		return null;
	}

}
