package spatial.algorithms.pointToFaceLocation;

import spatial.algorithms.AlgorithmResultBase;
import spatial.model.algorithms.pointToFaceLocation.IPointToFaceLocationResult;
import spatial.model.algorithms.pointToFaceLocation.PointToFaceLocationKind;

final class PointToFaceLocationResult extends AlgorithmResultBase implements IPointToFaceLocationResult
{
	final PointToFaceLocationKind locationKind;
	
	public PointToFaceLocationResult(PointToFaceLocationKind locationKind)
	{
		if (locationKind == null)
			throw new IllegalArgumentException("Location kind is not defined.");
		
		this.locationKind = locationKind;
	}

	public PointToFaceLocationResult(String[] errors)
	{
		super(errors);
		 
		this.locationKind = null;
	}

	@Override
	public PointToFaceLocationKind locationKind()
	{
		return this.locationKind;
	}

}
