package spatial.algorithms.pointToLineLocation;

import spatial.algorithms.AlgorithmResultBase;
import spatial.model.algorithms.pointToLineLocation.IPointToLineLocationResult;
import spatial.model.algorithms.pointToLineLocation.PointToLineLocationKind;

final class PointToLineLocationResult extends AlgorithmResultBase implements IPointToLineLocationResult
{
	private final PointToLineLocationKind locationKind;

	public PointToLineLocationResult(PointToLineLocationKind locationKind)
	{
		this.locationKind = locationKind;
	}

	public PointToLineLocationResult(String[] errors)
	{
		super(errors);
		
		this.locationKind = PointToLineLocationKind.NotSet;
	}

	@Override
	public final PointToLineLocationKind locationKind()
	{
		return this.locationKind;
	}

}
