package spatial.algorithms.pointToPlaneDistance;

import spatial.algorithms.AlgorithmResultBase;
import spatial.geometry.Vector3d;
import spatial.model.algorithms.pointToPlaneDistance.IPointToPlaneDistanceResult;

final class PointToPlaneDistanceResult extends AlgorithmResultBase implements IPointToPlaneDistanceResult
{

	private final double distance;
	
	private final Vector3d projectionPoint;
	
	public PointToPlaneDistanceResult(double distance, Vector3d projectionPoint)
	{
		if (projectionPoint == null)
			throw new IllegalArgumentException("The Projection Point is not defined.");
		
		this.distance = distance;
		this.projectionPoint = projectionPoint;
	}

	public PointToPlaneDistanceResult(String[] errors)
	{
		super(errors);

		this.distance = 0;
		this.projectionPoint = null;
	}

	@Override
	public double distance()
	{
		return this.distance;
	}

	@Override
	public Vector3d projectionPoint()
	{
		return this.projectionPoint;
	}

}
