package spatial.algorithms.pointToPolygonLocation;

import spatial.algorithms.AlgorithmResultBase;
import spatial.model.algorithms.pointToPolygonLocation.IPointToPolygonLocationResult;
import spatial.model.algorithms.pointToPolygonLocation.PointToPolygonLocationKind;

final class PointToPolygonLocationResult extends AlgorithmResultBase implements IPointToPolygonLocationResult
{
	private final PointToPolygonLocationKind locationKind;

	public PointToPolygonLocationResult(PointToPolygonLocationKind locationKind)
	{
		if (locationKind == null)
			throw new IllegalArgumentException("Location Kind is not defined.");
		
		this.locationKind = locationKind;
	}

	public PointToPolygonLocationResult(String[] errors)
	{
		super(errors);

		this.locationKind = null;
	}

	@Override
	public PointToPolygonLocationKind locationKind()
	{
		return this.locationKind;
	}

}
