package spatial.algorithms.polygon2dSelfIntersection;

import spatial.algorithms.AlgorithmResultBase;
import spatial.model.algorithms.polygon2dSelfIntersection.IPolygon2dSelfIntersectionResult;
import spatial.model.algorithms.polygon2dSelfIntersection.Polygon2dSelfIntersectionResultCode;

final class Polygon2dSelfIntersectionResult extends AlgorithmResultBase implements IPolygon2dSelfIntersectionResult
{

	private final Polygon2dSelfIntersectionResultCode resultCode;
	
	private final IntersectedPair intersectedPair;
	
	public Polygon2dSelfIntersectionResult(Polygon2dSelfIntersectionResultCode resultCode, IntersectedPair intersectedPair)
	{
		if (resultCode == null || resultCode == Polygon2dSelfIntersectionResultCode.NotSet)
			throw new IllegalArgumentException("The ResultCode is not defined.");
		if (resultCode != Polygon2dSelfIntersectionResultCode.NotSelfIntersected && intersectedPair == null)
			throw new IllegalArgumentException("The Intersected Pair of Edges is not defined.");
		
		this.resultCode = resultCode;
		this.intersectedPair = intersectedPair;
	}
	
	public Polygon2dSelfIntersectionResult(String[] errors)
	{
		super(errors);
		
		this.resultCode = null;
		this.intersectedPair = null;
	}
	
	@Override
	public Polygon2dSelfIntersectionResultCode resultCode()
	{
		return this.resultCode;
	}

	@Override
	public IntersectedPair intersectedPair()
	{
		return this.intersectedPair;
	}
	
}