package spatial.algorithms.polygonToPolygonLocation;

import spatial.algorithms.AlgorithmResultBase;
import spatial.model.algorithms.polygonToPolygonLocation.IPolygonToPolygonLocationResult;
import spatial.model.algorithms.polygonToPolygonLocation.PolygonToPolygonLocationKind;

final class PolygonToPolygonLocationResult extends AlgorithmResultBase implements IPolygonToPolygonLocationResult
{
	private final PolygonToPolygonLocationKind locationKind;
	
	private final IntersectedEdgesPair intersectedEdgesPair;
	
	public PolygonToPolygonLocationResult(PolygonToPolygonLocationKind locationCode, IntersectedEdgesPair intersectedEdgesPair)
	{
		if (locationCode == null)
			throw new IllegalArgumentException("Location Kind is not defined.");
		if (locationCode == PolygonToPolygonLocationKind.Intersects && intersectedEdgesPair == null)
			throw new IllegalArgumentException("Intersected Edges Pair is not defined.");
		
		this.locationKind = locationCode;
		this.intersectedEdgesPair = intersectedEdgesPair;
	}

	public PolygonToPolygonLocationResult(String[] errors)
	{
		super(errors);
		
		this.locationKind = PolygonToPolygonLocationKind.NotSet;
		this.intersectedEdgesPair = null;
	}

	@Override
	public PolygonToPolygonLocationKind locationCode()
	{
		return this.locationKind;
	}

	@Override
	public IntersectedEdgesPair intersectedEdgesPair()
	{
		return this.intersectedEdgesPair;
	}

}
