package spatial.geometry;

import precision.model.IPrecisionConfiguration;
import spatial.model.IGeometry;

abstract class EdgeXd<V> implements IGeometry
{
	protected final V vectorA;
	
	protected final V vectorB;
	
	public EdgeXd(V vectorA, V vectorB)
	{
		this.vectorA = vectorA;
		this.vectorB = vectorB;
	}
	
	public final V vectorA()
	{
		return this.vectorA;
	}
	
	public final V vectorB()
	{
		return this.vectorB;
	}

	public abstract V edgeVector(IPrecisionConfiguration precisionConfiguration);
}