package spatial.geometry;

import spatial.model.IGeometry;

/**
 * The Face Geometry is a set of polygons lied in one plane.
 */
public final class Face2d implements IGeometry
{

	private final Polygon2d[] polygons;
	
	public Face2d(Polygon2d[] polygons)
	{
		if (polygons == null)
			throw new IllegalArgumentException("The Polygons are not defined.");
		if (polygons.length == 0)
			throw new IllegalArgumentException("Face can't be create from zero polygons.");
		
		this.polygons = polygons;
	}

	public Polygon2d[] polygons()
	{
		return this.polygons;
	}
}