package spatial.geometry;

import spatial.model.IGeometry;

/**
 * The Face Geometry is a set of polygons lied in one plane.
 */
public final class Face3d implements IGeometry
{
	private final Polygon3d[] polygons;

	public Face3d(Polygon3d[] polygons)
	{
		if (polygons == null)
			throw new IllegalArgumentException("The Polygons are not defined.");
		if (polygons.length == 0)
			throw new IllegalArgumentException("Face can't be create from zero polygons.");
		
		this.polygons = polygons;
	}

	public Polygon3d[] polygons()
	{
		return this.polygons;
	}
	
}
