package spatial.geometry;

import precision.model.IPrecisionConfiguration;
import spatial.model.IGeometry;

public class Plane3d implements IGeometry
{
	private final Vector3d normalUnitVector;
	
	private final Vector3d pointOnThePlane;
	
	public Plane3d(Vector3d normalVector, Vector3d pointOnThePlane)
	{
		this.normalUnitVector = normalVector;
		this.pointOnThePlane = pointOnThePlane;
	}
	
	public Plane3d(double a0, double a1, double a2, double a3, IPrecisionConfiguration precisionConfiguration)
	{
		this.normalUnitVector = new Vector3d(a0, a1, a2, precisionConfiguration).unitVector(precisionConfiguration);
		this.pointOnThePlane = new Vector3d(0, 0, -a3 / a2, precisionConfiguration);
	}
	
	public final Vector3d normalUnitVector()
	{
		return this.normalUnitVector;
	}
	
	public final Vector3d pointOnThePlane()
	{
		return this.pointOnThePlane;
	}
}
