package spatial.model;

import precision.model.IPrecisionConfiguration;
import spatial.model.elements.set.IEdgeSet;
import spatial.model.elements.set.INodeSet;

/**
 * The main spatial Model.
 */
public interface ISpatialModel 
{
	/**
	 * The precision configuration used in the Model.
	 */
	IPrecisionConfiguration precisionConfiguration();
	
	/**
	 * The set of nodes existed in the Model.
	 */
	INodeSet nodes();
	
	/**
	 * The set of edges existed in the Model.
	 */
	IEdgeSet edges();
	
}
