package spatial.model.algorithms.bestFittingPlane;

import spatial.geometry.Vector3d;

/**
 * Plane Defined by a Point Set.
 */
public interface IBestFittingPlaneAlgorithm
{
	
	/**
	 * Determine the plane which minimises the sum of the squares of the normal distances of a given point set from this plane
	 * @param points The unit normal vector n of the plane.
	 */
	IBestFittingPlaneResult calculate(Vector3d[] points);

}