package spatial.model.algorithms.bestFittingPlane;

import spatial.geometry.Plane3d;
import spatial.model.algorithms.IAlgorithmResult;

public interface IBestFittingPlaneResult extends IAlgorithmResult
{
	/**
	 * Calculated best fitting plane, constructed from the centroid point and calculated normal vector.
	 */
	Plane3d bestFittingPlane();
	
	/**
	 * Normal distances of the points from the plane.
	 */
	double[] sourcePointsDistances();
}