package spatial.model.algorithms.csTransformation;

import org.ejml.data.DMatrix;

import spatial.geometry.Vector3d;
import spatial.model.algorithms.IAlgorithmResult;

public interface ICsTransformationResult extends IAlgorithmResult
{
	/**
	 * The rotation matrix R of the local coordinate system.
	 */
	DMatrix rotationMatrix();
	
	/**
	 * The given point set with coordinates transformed to local CS.
	 */
	Vector3d[] localPoints();
}
