package spatial.model.algorithms.edgeToEdgeLocation;

import spatial.geometry.Edge2d;

/**
 * Intersection of Two Edges in a Plane
 */
public interface IEdgeToEdgeLocationAlgorithm 
{
	/**
	 * Determine the local coordinates of the point of intersection of two lines 
	 * containing given edges AB and CD, and the location of the point of intersection 
	 * relative to edges AB and CD
	 * @param edge1 The edge 1 in 2D.
	 * @param edge2 The edge 2 in 2D.
	 */
	IEdgeToEdgeLocationResult calculate(Edge2d edge1, Edge2d edge2);
}
