package spatial.model.algorithms.edgeToEdgeLocation;

import spatial.geometry.Vector2d;
import spatial.model.algorithms.IAlgorithmResult;

public interface IEdgeToEdgeLocationResult extends IAlgorithmResult
{
	/**
	 * Edges intersection type code.
	 */
	EdgeToEdgeLocationKind locationCode();

	/**
	 * The local coordinates of the intersection point (if location code is "NotParallel").
	 */
	Vector2d intersectionPoint();
	
	double r0();
	
	double t0();
	
	double rc();
	
	double rd();
	
	/**
	 * Intersection point lies inside on of the edges and belongs to other.
	 */
	boolean edgesIntersectInside();
	
	/**
	 * Intersection point belongs to boundary nodes of the both edges.
	 */
	boolean edgesIntersectAtNode();
}
