package spatial.model.algorithms.edgeToPolygonLocation;

import spatial.geometry.Edge3d;
import spatial.geometry.Polygon3d;
import spatial.geometry.Vector3d;

/**
 * Location of an Edge Relative to a Polygon.
 */
public interface IEdgeToPolygonLocationAlgorithm
{
	/**
	 * Location of an Edge Relative to a Polygon.
	 * @param planeNormalUnitVector Plane normal unit vector.
	 * @param polygon The polygon.
	 * @param testEdge The Test Edge.
	 */
	IEdgeToPolygonLocationResult calculate(Vector3d planeNormalUnitVector, Polygon3d polygon, Edge3d testEdge);
}
