package spatial.model.algorithms.pointToEdgeDistance;

import spatial.geometry.Edge3d;
import spatial.geometry.Vector3d;

/**
 * The algorithm "Distance Between a Point and an Edge".
 */
public interface IPointToEdgeDistanceAlgorithm
{
	/**
	 * Determine the distance between a test node T and an edge AB as follows:
	 * - normal distance to an interior point of edge AB, or
	 * - smaller of the distances TA and TB
	 * @param edge The edge in 3D.
	 * @param point The Test point in 3D.
	 */
	IPointToEdgeDistanceResult calculate(Edge3d edge, Vector3d point);
}