package spatial.model.algorithms.pointToEdgeDistance;

import spatial.geometry.Vector3d;
import spatial.model.algorithms.IAlgorithmResult;

public interface IPointToEdgeDistanceResult extends IAlgorithmResult
{
	/**
	 * The Kind of distance.
	 */
	PointToEdgeLocationKind distancePointLocationKind();
	
	/**
	 * The projection Point of the Test Point on the Edge line.
	 */
	Vector3d edgeDistancePoint();
	
	Vector3d projectionPoint();
	
	/**
	 * The absolute distance between the Point and the Edge.
	 */
	double distance();
}