package spatial.model.algorithms.pointToFaceLocation;

import spatial.geometry.Face3d;
import spatial.geometry.Vector3d;

/**
 * Location of a Test Point Relative to a Face in a Plane.
 */
public interface IPointToFaceLocationAlgorithm
{
	/**
	 * Determine whether a test point T is an interior or an exterior point of a face F whose plane contains T.
	 * @param planeNormalUnitVector Plane normal unit vector.
	 * @param face The face.
	 * @param testPoint 3D global coordinates of the test point T 
	 */
	IPointToFaceLocationResult calculate(Vector3d planeNormalUnitVector, Face3d face, Vector3d testPoint);
}
