package spatial.model.algorithms.pointToLineLocation;

import spatial.geometry.Line3d;
import spatial.geometry.Vector3d;

/**
 * The algorithm "Location of a Point Relative to a Directed Line".
 */
public interface IPointToLineLocationAlgorithm
{
	/**
	 * Determine the location of a test point T relative to a directed line.
	 * Both, the Line and the Test point, belongs to the plane.
	 * @param plainNormalVector Unit normal vector n of the plane.
	 * @param line The Line in 3D.
	 * @param testPoint The Test Point in 3d.
	 */
	IPointToLineLocationResult calculate(Vector3d plainNormalVector, Line3d line, Vector3d testPoint);
}