package spatial.model.algorithms.pointToPlaneDistance;

import spatial.geometry.Plane3d;
import spatial.geometry.Vector3d;

/**
 * Distance Between a Point in Space and a Plane  
 */
public interface IPointToPlaneDistanceAlgorithm
{
	/**
	 * Determine the smallest distance from a test point T to a given plane in 3D space
	 * @param plane The plane.
	 * @param testPoint The Test Point in 3d.
	 */
	IPointToPlaneDistanceResult calculate(Plane3d plane, Vector3d testPoint);
}
