package spatial.model.algorithms.pointToPlaneDistance;

import spatial.geometry.Vector3d;
import spatial.model.algorithms.IAlgorithmResult;

public interface IPointToPlaneDistanceResult extends IAlgorithmResult
{
	/**
	 * Normal distance of test point T from the plane.
	 */
	double distance();
	
	/**
	 * 3D global coordinates of the point of intersection S of the normal vector 
	 * through point T with the plane.
	 */
	Vector3d projectionPoint();
}
