package spatial.model.algorithms.pointToPolygonDistance;

import spatial.geometry.Polygon3d;
import spatial.geometry.Vector3d;

/**
 * Nearest Point of the Boundary of a Polygon.
 */
public interface IPointToPolygonDistanceAlgorithm
{
	/**
	 * Determine the inner point of an edge or the node of a plane polygon which is the nearest point of the boundary to a test point T in the plane.
	 * @param planeNormalUnitVector 3D global coordinates of the unit normal vector n of the plane.
	 * @param polygon Plane polygon.
	 * @param testPoint 3D global coordinates of a test point T in the plane
	 */
	IPointToPolygonDistanceResult calculate(Vector3d planeNormalUnitVector, Polygon3d polygon, Vector3d testPoint);
}
