package spatial.model.algorithms.pointToPolygonDistance;

import spatial.geometry.Vector3d;
import spatial.model.algorithms.IAlgorithmResult;
import spatial.model.algorithms.pointToEdgeDistance.PointToEdgeLocationKind;

public interface IPointToPolygonDistanceResult extends IAlgorithmResult
{
	/**
	 * Least distance between test point T and a point S on the boundary of the polygon.
	 */
	double distance();
	
	/**
	 * 3D global coordinates of point S (on the boundary of the polygon).
	 */
	Vector3d polygonDistancePoint();
	
	/**
	 * Identifier of the edge on which point S is located.
	 */
	int edgeIndex();
	
	/**
	 * Location of point S on the edge.
	 */
	PointToEdgeLocationKind distancePointLocationKind();
	
	/**
	 * The projection of the Test point to the polygons edge line to which distance has been measured.
	 */
	Vector3d polygonDistanceProjectionPoint();
}

