package spatial.model.algorithms.pointToPolygonLocation;

import spatial.geometry.Polygon3d;
import spatial.geometry.Vector3d;

/**
 * Location of a Point Relative to an Oriented Polygon
 */
public interface IPointToPolygonLocationAlgorithm
{
	/**
	 * A plane with unit normal vector n contains an oriented polygon and a test point T. 
	 * It is to be determined whether T is an interior or an exterior point of the polygon.
	 * @param planeNormalUnitVector 3D global coordinates of the unit normal vector n of the plane.
	 * @param polygon 3D Polygon P.
	 * @param testPoint 3D global coordinates of a test point T in the plane
	 * @return
	 */
	IPointToPolygonLocationResult calculate(Vector3d planeNormalUnitVector, Polygon3d polygon, Vector3d testPoint);
}
