package spatial.model.algorithms.polygon2dSelfIntersection;

import spatial.geometry.Polygon3d;
import spatial.geometry.Vector3d;

/**
 * Self-Intersection of a Plane Polygon.
 */
public interface IPolygon2dSelfIntersectionAlgorithm
{
	/**
	 * Determine whether any edges of a polygon intersect.
	 * @param planeNormalUnitVector 3D global coordinates of the unit normal vector n of the plane.
	 * @param polygon Plane polygon with nodes coordinates in 3D.
	 */
	IPolygon2dSelfIntersectionResult calculate(Vector3d planeNormalUnitVector, Polygon3d polygon);
}
