package spatial.model.algorithms.polygon2dSelfIntersection;

import spatial.model.algorithms.IAlgorithmResult;

public interface IPolygon2dSelfIntersectionResult extends IAlgorithmResult
{
	/**
	 * The quality result of the test.
	 */
	Polygon2dSelfIntersectionResultCode resultCode();
	
	/**
	 * The first determined pair of self-intersected edges.
	 */
	IntersectedPair intersectedPair();
	
	public class IntersectedPair
	{
		/**
		 * Index of the self intersected edge.
		 */
		public final int EdgeIx1;
		
		/**
		 * Index of the self intersected edge.
		 */
		public final int EdgeIx2;
		
		public IntersectedPair(int edgeIx1, int edgeIx2)
		{
			this.EdgeIx1 = edgeIx1;
			this.EdgeIx2 = edgeIx2;
		}
	}
}
