package spatial.model.algorithms.polygonToPolygonLocation;

import spatial.geometry.Polygon3d;
import spatial.geometry.Vector3d;

/**
 * Intersection of Two Polygons in Plane
 */
public interface IPolygonToPolygonLocationAlgorithm
{
	/**
	 * Determine whether at least one edge of polygon P1 intersects at least one edge of polygon P2.
	 * @param planeNormalUnitVector 3D global coordinates of the unit normal vector n of the plane.
	 * @param polygon1 The polygon 1.
	 * @param polygon2 The polygon 2.
	 */
	IPolygonToPolygonLocationResult calculate(Vector3d planeNormalUnitVector, Polygon3d polygon1, Polygon3d polygon2);
}