package spatial.model.algorithms.polygonToPolygonLocation;

import spatial.model.algorithms.IAlgorithmResult;

public interface IPolygonToPolygonLocationResult extends IAlgorithmResult
{
	/**
	 * The kind of polygons location.
	 */
	PolygonToPolygonLocationKind locationCode();
	
	/**
	 * The first determined pair of intersected edges from polygons.
	 */
	IntersectedEdgesPair intersectedEdgesPair();
	
	public class IntersectedEdgesPair
	{
		/**
		 * The index of the intersected edge from the first polygon.
		 */
		public final int EdgeIx1;
		
		/**
		 * The index of the intersected edge from the second polygon.
		 */
		public final int EdgeIx2;
		
		public IntersectedEdgesPair(int edgeIx1, int edgeIx2)
		{
			this.EdgeIx1 = edgeIx1;
			this.EdgeIx2 = edgeIx2;
		}
	}
	
}
