package spatial.model.elements.set.exception;

/**
 * The element geometry of not valid type.
 */
public class ElementGeometryOfNotValidTypeException extends Exception 
{
	private static final long serialVersionUID = 553492353501925668L;

	private String expectedType;
	
	private String actualType;
	
	/**
	 * Constructor.
	 * @param expectedType Expected type of geometry.
	 * @param actualType Actually recieved type of geometry.
	 */
	public ElementGeometryOfNotValidTypeException(String expectedType, String actualType)
	{
		this.expectedType = expectedType;
		this.actualType = actualType;
	}
	
	@Override
	public String getMessage()
	{
		return "Element geometry of not a valid type (expected [" + this.expectedType + "], recieved [" + this.actualType + "]).";
	}
}
