package spatial.model.elements.set.exception;

/**
 * Element with the same geometry already exists in the model under different name exception.
 */
public class ElementWithTheSameGeometryAlreadyExistsException extends Exception 
{
	private static final long serialVersionUID = 7285167654967663286L;
	
	private String existedElementName;
	
	private String addedElementName;
	
	private String geometry;
	
	/**
	 * Constructor.
	 * @param geometry The string representation of the geometry.
	 * @param existedElementName The existed element name for geometry.
	 * @param addedElementName The added element name for the same geometry.
	 */
	public ElementWithTheSameGeometryAlreadyExistsException(String geometry, String existedElementName, String addedElementName)
	{
		this.existedElementName = existedElementName;
		this.addedElementName = addedElementName;
		this.geometry = geometry;
	}
	
	@Override
	public String getMessage()
	{
		return "Element with the same geometry already exists in the model under different name ([" + this.geometry + "][" + this.addedElementName + "][" + this.existedElementName + "]).";
	}
}
