package spatial.model.elements.set.exception;

/**
 * Element with the same name but different geometry already exists in the model exception.
 */
public class ElementWithTheSameNameAlreadyExistsException extends Exception 
{
	private static final long serialVersionUID = -3342215696257805049L;
	
	private String elementName;
	
	private String addedGeometry;
	
	private String existedGeometry;
	
	/**
	 * Constructor.
	 * @param elementName The element name.
	 * @param addedGeometry The string representation of the added geometry.
	 * @param existedGeometry The string representation of the existed in the model geometry.
	 */
	public ElementWithTheSameNameAlreadyExistsException(String elementName, String addedGeometry, String existedGeometry)
	{
		this.elementName = elementName;
		this.addedGeometry = addedGeometry;
		this.existedGeometry = existedGeometry;
	}
	
	@Override
	public String getMessage()
	{
		return "Element with the same name but different geometry alredy exists in the model ([" + elementName + "][" + this.addedGeometry + "][" + this.existedGeometry + "]).";
	}
}
