package cga;

import static org.junit.jupiter.api.Assertions.assertEquals;

import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.Test;

import precision.PrecisionConfiguration;
import precision.model.IPrecisionConfiguration;
import spatial.algorithms.faceArea.FaceAreaAlgorithm;
import spatial.geometry.Face2d;
import spatial.geometry.Polygon2d;
import spatial.geometry.Vector2d;
import spatial.model.algorithms.faceArea.IFaceAreaAlgorithm;
import spatial.model.algorithms.faceArea.IFaceAreaResult;

class FaceAreaFixture
{

	private static IPrecisionConfiguration precisionConfiguration;
	
	@BeforeAll
	static void setUpBeforeClass() throws Exception
	{
		precisionConfiguration = new PrecisionConfiguration(4, 0.0001);
	}

	@Test
	void testCalculate()
	{
		//arrange
		Face2d face = new Face2d(new Polygon2d[] {
				new Polygon2d(new Vector2d[] {
						new Vector2d(10, 10, precisionConfiguration),
						new Vector2d(37.5, 10, precisionConfiguration),
						new Vector2d(37.5, 27.5, precisionConfiguration),
						new Vector2d(17.5, 27.5, precisionConfiguration)
				}),
				
				new Polygon2d(new Vector2d[] {
						new Vector2d(21.5, 14.5, precisionConfiguration),
						new Vector2d(24.5, 25, precisionConfiguration),
						new Vector2d(33, 14.5, precisionConfiguration)
				})				
		});

		//act
		IFaceAreaAlgorithm algorithm = new FaceAreaAlgorithm(precisionConfiguration);
		IFaceAreaResult result = algorithm.calculate(face);
		
		//assert
		
		assertEquals(415.625 - 60.375, result.area());
	}

}