package cga;

import static org.junit.jupiter.api.Assertions.*;

import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.Test;

import precision.PrecisionConfiguration;
import precision.model.IPrecisionConfiguration;
import spatial.geometry.ClockWiseType;
import spatial.geometry.Polygon3d;
import spatial.geometry.Vector3d;

class Polygon3dFixture
{

	private static IPrecisionConfiguration precisionConfiguration;
	
	@BeforeAll
	static void setUpBeforeClass() throws Exception
	{
		precisionConfiguration = new PrecisionConfiguration(4, 0.0001);
	}

	@Test
	void testClockWiseType01()
	{
		Polygon3d polygon = new Polygon3d(new Vector3d[]
				{
					new Vector3d(17.5, 7.5, 0, precisionConfiguration),
					new Vector3d(20, 5, 0, precisionConfiguration),
					new Vector3d(20, 6, 0, precisionConfiguration),
					new Vector3d(19.5, 7, 0, precisionConfiguration),
					new Vector3d(19, 7.5, 0, precisionConfiguration),
					new Vector3d(18, 7.5, 0, precisionConfiguration),
					new Vector3d(18, 10, 0, precisionConfiguration),
					new Vector3d(19, 11, 0, precisionConfiguration),
					new Vector3d(18, 11, 0, precisionConfiguration),
					new Vector3d(17.5, 10.5, 0, precisionConfiguration)
				});
		Vector3d planeNormalUnitVector = new Vector3d(0, 0, 1, precisionConfiguration);
		
		ClockWiseType cwt = polygon.clockWiseType(planeNormalUnitVector, precisionConfiguration);
		
		assertEquals(ClockWiseType.CounterClockWise, cwt);
	}
	
	@Test
	void testClockWiseType02()
	{
		Polygon3d polygon = new Polygon3d(new Vector3d[]
				{
					new Vector3d(17.5, 7.5, 0, precisionConfiguration),
					new Vector3d(17.5, 10.5, 0, precisionConfiguration),
					new Vector3d(18, 11, 0, precisionConfiguration),
					new Vector3d(19, 11, 0, precisionConfiguration),
					new Vector3d(18, 10, 0, precisionConfiguration),
					new Vector3d(18, 7.5, 0, precisionConfiguration),
					new Vector3d(19, 7.5, 0, precisionConfiguration),
					new Vector3d(19.5, 7, 0, precisionConfiguration),
					new Vector3d(20, 6, 0, precisionConfiguration),
					new Vector3d(20, 5, 0, precisionConfiguration)
				});
		Vector3d planeNormalUnitVector = new Vector3d(0, 0, 1, precisionConfiguration);
		
		ClockWiseType cwt = polygon.clockWiseType(planeNormalUnitVector, precisionConfiguration);
		
		assertEquals(ClockWiseType.ClockWise, cwt);
	}

}
