package cga;

import static org.junit.jupiter.api.Assertions.*;

import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.Test;

import precision.PrecisionConfiguration;
import precision.model.IPrecisionConfiguration;
import spatial.algorithms.polygonArea.PolygonAreaAlgorithm;
import spatial.geometry.Polygon2d;
import spatial.geometry.Vector2d;
import spatial.model.algorithms.polygonArea.IPolygonAreaAlgorithm;
import spatial.model.algorithms.polygonArea.IPolygonAreaResult;

class PolygonAreaFixture
{

	private static IPrecisionConfiguration precisionConfiguration;
	
	@BeforeAll
	static void setUpBeforeClass() throws Exception
	{
		precisionConfiguration = new PrecisionConfiguration(4, 0.0001);
	}

	@Test
	void testCalculate()
	{
		//arrange
		Polygon2d polygon = new Polygon2d(new Vector2d[] {
				new Vector2d(10, 10, precisionConfiguration),
				new Vector2d(37.5, 10, precisionConfiguration),
				new Vector2d(37.5, 27.5, precisionConfiguration),
				new Vector2d(17.5, 27.5, precisionConfiguration)
		});
		
		//act
		IPolygonAreaAlgorithm algorithm = new PolygonAreaAlgorithm(precisionConfiguration);
		IPolygonAreaResult result = algorithm.calculate(polygon);
		
		//assert
		
		assertEquals(415.625, result.area());
	}

}