package cga;

import static org.junit.jupiter.api.Assertions.*;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

import precision.PreciseDoubleFactory;
import precision.PrecisionConfiguration;
import precision.model.IPreciseDoubleFactory;
import precision.model.IPrecisionConfiguration;
import spatial.geometry.Vector3d;

class Vector3dFixture {

	private IPrecisionConfiguration precisionConfiguration;
	private IPreciseDoubleFactory preciseDoubleFactory;
	
	@BeforeEach
	void setUpBeforeEach() throws Exception
	{
		this.precisionConfiguration = new PrecisionConfiguration(4, 0.000009);
		this.preciseDoubleFactory = new PreciseDoubleFactory(this.precisionConfiguration);
    }

	@Test
	void testHashCode() 
	{
		Vector3d v1 = new Vector3d(10, 20, 30, this.preciseDoubleFactory);
		Vector3d v2 = new Vector3d(30, 10, 20, this.preciseDoubleFactory);
		Vector3d v3 = new Vector3d(0, 20, 30, this.preciseDoubleFactory);
		
		assertNotEquals(v1.hashCode(), v2.hashCode());
		assertNotEquals(v1.hashCode(), v3.hashCode());
	}

	@Test
	void testXYZ() 
	{
		Vector3d v1 = new Vector3d(10, 20, 30, this.preciseDoubleFactory);
		
		assertEquals(10, v1.x());
		assertEquals(20, v1.y());
		assertEquals(30, v1.z());
	}

	@Test
	void testEqualsObject() 
	{
		Vector3d v1 = new Vector3d(10, 20, 30, this.preciseDoubleFactory);
		Vector3d v2 = new Vector3d(30, 10, 20, this.preciseDoubleFactory);
		Vector3d v3 = new Vector3d(10, 20, 30, this.preciseDoubleFactory);
		
		assertNotEquals(v1, v2);
		assertEquals(v1, v3);
	}

}
